#! /bin/sh
#
#   mainmenu.sh -- CD-ROMǥᥤ˥塼
#
#	0.0: Jun. 20, 2004 by Dai ISHIJIMA (for wpout03)
#	0.1: Jul. 11  2004 (for wpout04)
#	0.2: Jun. 23  2005 (for wpout05)
#	0.3: Jul.  8  2005 (for wpout06)
#	0.4: Aug.  5, 2006 (for wpout07)
#	0.5: Dec. 21, 2006 (erase MBR)
#	0.6: Feb. 10, 2007 (Ͽ for wpout08)
#

dmesg="${DMESG:-/var/run/dmesg.boot}"
devices="${DEVICES:-da|ad|ar|aacd|amrd}"
resultfil=/tmp/result
nsec=/tmp/sector
stuffs='10'
sed -n -E "/^(${devices})[0-9]:.*</p" $dmesg |
	sed 's/^\([a-z][a-z]*[0-9]\).*/\1/' > $resultfil
disk=`sed -n '1p' $resultfil`
export TITLE='ϡɥǥõġwipe-out'
dumpskip=0

echo -n "script mainmenu.sh started on " >> $LOGFIL
date >> $LOGFIL

while true ; do
	dname=`sed -n -E "/^${disk}:.*<.*>/p" $dmesg | sed 's/.*\(<.*>\).*/\1/'`
	bytes=`diskinfo -B /dev/r$disk`
	cap=`diskinfo -p /dev/r$disk`

	msg="                      ᥤ˥塼\n"
	msg="${msg}Υǥ /dev/${disk} ${dname} Ǥ\n"
	msg="${msg}ǥ̤ $bytes Х ($cap) Ǥ\n"
	msg="${msg}ʲΥ˥塼򤷤Ƥ\n"

	dialog 	2>$resultfil \
		--title "$TITLE" \
		--menu "$msg" \
		19 74 7 \
		z '0񤭤ơΥǥΥǡä' \
		f '1񤭤ơΥǥΥǡä' \
		r 'ǡ񤭤ơΥǥΥǡä' \
		s '̤Υǥ򤹤' \
		n 'ʣ񤭤ơΥǥΥǡǰ˾ä' \
		m 'ǰõξˡ򤹤' \
		v 'ǡõ줿ǧ (®å)' \
		V 'ǡõ줿ǧ (̾å)' \
		w 'õǥ˽񤭹' \
		L 'ưϿեåԡ˽񤭽Ф' \
		d 'ǥΥǡɽ' \
		S 'ǡɽ륻λ' \
		a '֡wipe-out٤ˤĤơפ򸫤' \
		D 'ưΥƥåǧ' \
		p 'ѥ񤭤ơΥǥΥǡä' \
		q 'ѥ񤭤ơΥǥΥǡä' \
		y 'ǥ򥳥ԡ' \
		b ' (sh) ư' \
		t ' (csh) ư' \
		M 'CD-ROMmount' \
		U 'CD-ROMumount' \
		B 'MBR *Τ* õ' \
		x 'åȥ󤹤' \
		R 'Ƶư'
	case x"$?" in
		x1)
			break
			;;
	esac

	result=`cat $resultfil`

	case x"${result}" in
		x[zfrpq])
			sh erase.sh -$result $disk
			;;
		xs)
			. seldisk.sh
			;;
		xn)
			sh fine-erase.sh $stuffs $disk
			;;
		xm)
			. sel-fine.sh
			;;
		xv)
			sh verify.sh 90 $disk
			;;
		xV)
			sh verify.sh 0 $disk
			;;
		xw)
			sh writelog.sh $disk
			;;
		xL)
			sh floppylog.sh fd0
			;;
		xd)
			sh dump.sh $dumpskip $disk
			dumpskip=`expr $dumpskip + 1`
			;;
		xS)
			msg="ꤷƤ ($dumpskip)"
			dialog	2>/tmp/sector \
				--title "$TITLE" \
				--inputbox "$msg" 8 64
			case x"$?" in
			    x0)
				echo '' >> $nsec
				echo "$dumpskip" >> $nsec
				dumpskip=`sed -n '/^[0-9]/p' $nsec | sed -n 1p`
				;;
			esac
			;;
		xa)
			dialog	--title 'wipe-out٤ˤĤ' \
				--textbox info.txt 22 76
			;;
		xD)
			dialog	--title 'ưΥƥå' \
				--textbox /var/run/dmesg.boot 22 76
			;;
		xy)
			srcdisk=$disk
			. seldisk.sh
			dstdisk=$disk
			sh copy.sh $srcdisk $dstdisk
			disk=$srcdisk
			;;
		xb)
			/bin/sh -i
			;;
		xt)
			if [ -x /bin/csh ]; then
				/bin/csh -i
			else
				msg='cshäCD-ROMޥȤƤ'
				dialog	--title "$TITLE" \
					--msgbox "$msg" 5 64
			fi
			;;
		xM)
			if [ -x /cdrom/usr.bin/dialog ]; then
				msg='CD-ROMϤǤ˥ޥȤƤޤ'
			elif mount_cd9660 $CDROM /cdrom > /dev/null 2>&1; then
				msg='CD-ROMޥȤޤ'
			else
				msg='CD-ROMޥȤǤޤǤ'
			fi
			dialog	--title "$TITLE" \
				--msgbox "$msg" 5 64
			;;
		xU)
			msg=''
			if [ ! -x /cdrom/usr.bin/dialog ]; then
				msg='CD-ROMϤǤ˥ޥȤƤޤ'
			fi
			if umount /cdrom > /dev/null 2>&1; then
				msg='CD-ROM򥢥ޥȤޤ'
			elif [ -z "$msg" ]; then
				msg='CD-ROMޥȤǤޤǤ'
			fi
			dialog	--title "$TITLE" \
				--msgbox "$msg" 5 64
			;;
		xB)
			sh embr.sh $disk
			;;
		xx)
			init 0
			;;
		xR)
			init 6
			;;
	esac
done

dialog	--title "$TITLE" \
	--infobox 'λޤ' 3 48

echo '/bin/sh /wipeout/mainmenu.shפǥ˥塼̤ƤӽФޤ'
echo ''

exit 0

# EOF
