#! /bin/sh
#
#   floppylog.sh -- եåԡ˥Ͽ
#
#	Ȥ: /bin/sh floppylog.sh ǥ
#		ǥ: ǥХեǻꡢƬΡ/dev/rפϾʤ
#		: /bin/sh floppylog.sh fd0
#
#	0.0: Feb. 10, 2007 by Dai ISHIJIMA (for wpout08)
#

dmesg="${DMESG:-/var/run/dmesg.boot}"
disk="${1:-fd0}"

header=/tmp/header.txt

title="${TITLE:-ϡɥǥõġwipe-out}"

if ! mount_msdos -s -o rdonly /dev/$disk /floppy > /dev/null 2>&1; then
	msg="ǥ ${disk} ޥȤǤޤǤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi

if [ ! -d /floppy/wipe-out ]; then
	msg="ǥ ${disk} ˥񤭹ߥǥ쥯ȥ꤬ޤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi

if ! umount /floppy > /dev/null 2>&1; then
	msg="ǥ ${disk} 򥢥ޥȤǤޤǤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi

if ! mount_msdos -s /dev/$disk /floppy > /dev/null 2>&1; then
	msg="ǥ ${disk} 񤭹ߥޥȤǤޤǤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi

echo "####" > $header
echo -n "following messages were logged on " >> $header
date >> $header
echo "====" >> $header

# dmesg.boot
if ! crlf.sh < $header >> /floppy/wipe-out/dmsgboot.txt ; then
	umount /floppy
	msg="dmesg.bootإåν񤭹ߤ˼Ԥޤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi
if ! crlf.sh < $dmesg >> /floppy/wipe-out/dmsgboot.txt ; then
	umount /floppy
	msg="dmesg.bootν񤭹ߤ˼Ԥޤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi

# dmesg-a
if ! crlf.sh < $header >> /floppy/wipe-out/dmesg-a.txt ; then
	umount /floppy
	msg="dmesg -a إåν񤭹ߤ˼Ԥޤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi
if ! dmesg -a | crlf.sh >> /floppy/wipe-out/dmesg-a.txt ; then
	umount /floppy
	msg="dmesg -a ν񤭹ߤ˼Ԥޤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi

# wpoutlog.txt
if ! crlf.sh < $header >> /floppy/wipe-out/wpoutlog.txt ; then
	umount /floppy
	msg="wipe-outإåν񤭹ߤ˼Ԥޤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi
if ! crlf.sh < $LOGFIL >> /floppy/wipe-out/wpoutlog.txt ; then
	umount /floppy
	msg="wipe-outν񤭹ߤ˼Ԥޤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi

# mbrlog.txt
if ! crlf.sh < $header >> /floppy/wipe-out/mbrlog.txt ; then
	umount /floppy
	msg="MBRإåν񤭹ߤ˼Ԥޤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi
eraselog='No erase log found'
for i in /tmp/erase-log.* ; do
	if [ -f "$i" ]; then
		if ! crlf.sh < $i >> /floppy/wipe-out/mbrlog.txt ; then
			umount /floppy
			msg="MBR ($i) ν񤭹ߤ˼Ԥޤ"
			dialog --title "$title" --msgbox "$msg" 5 64
			exit 1
		fi
	fi
	eraselog=''
done
case x"$eraselog" in
    xNo*)
	if ! echo "$eraselog" | crlf.sh >> /floppy/wipe-out/mbrlog.txt ; then
		umount /floppy
		msg="MBRν񤭹ߤ˼Ԥޤ"
		dialog --title "$title" --msgbox "$msg" 5 64
		exit 1
	fi
esac
verifylog='No verify log found'
for i in /tmp/verify-log.* ; do
	if [ -f "$i" ]; then
		if ! crlf.sh < $i >> /floppy/wipe-out/mbrlog.txt ; then
			umount /floppy
			msg="MBR ($i) ν񤭹ߤ˼Ԥޤ"
			dialog --title "$title" --msgbox "$msg" 5 64
			exit 1
		fi
	fi
	verifylog=''
done
case x"$verifylog" in
    xNo*)
	if ! echo "$verifylog" | crlf.sh >> /floppy/wipe-out/mbrlog.txt ; then
		umount /floppy
		msg="MBRν񤭹ߤ˼Ԥޤ"
		dialog --title "$title" --msgbox "$msg" 5 64
		exit 1
	fi
esac

if ! umount /floppy > /dev/null 2>&1; then
	msg="񤭹߸˥ǥ ${disk} 򥢥ޥȤǤޤǤ"
	dialog --title "$title" --msgbox "$msg" 5 64
	exit 1
fi

dialog	--title "$title" \
	--msgbox "ν񤭹ߤλޤ" 5 64

exit 0

# EOF
